/*********************************************************************

         FILE:  basic_demod_types.h

   PROGRAMMER:  Roger Hammons
                Hughes Network Systems
                11717 Exploration Lane
                Germantown, MD 20878
                e-mail:  rhammons@hns.com
                tel:     (301) 428-2784
                fax:     (301) 428-2750
                
      PURPOSE:  This file contains the constant parameters and 
                data types required by the Basic_Demod subroutine.  

 REVISION HISTORY:  
   10-19-98   rh   Initial version.
   10-22-98   rh   Added parameters to support coded algorithms.  

*********************************************************************/


/*********************************************************************
               CONSTANTS
*********************************************************************/

#define MAXSYMPERSLOT 100
#define MAXCHNLTAPS 7

#define PILOT_START 0
#define PILOT_END   3

#define POWER_UP 1
#define POWER_DN 0
#define POWER_IDLE -1  

#define ZEROTOL 1.e-10

/*********************************************************************
               DATA TYPES 
*********************************************************************/

struct DATA {
   double Re;
   double Im;
};

struct NOISE {
   double Re1;
   double Im1;
   double Re2;
   double Im2;
   double Re3;
   double Im3;
   double Re4;
   double Im4;
   double Re5;
   double Im5;
   double Re6;
   double Im6;
   double Re7;
   double Im7;
};
