/*************************************************************************/
/*************************  INITIALIZE      *****************************/
/*************************************************************************/
void initialize()
{
int i0;
char name[128];

/************************ PERMUTATION ***********************************/
fgets(stringa,128,f_input);                  /* inizialize the LFSR circuit*/
fscanf(f_input,"%[^\n^\r]\r\n",name);
printf("Opening permutation file...");
f_perm    =fopen(name,"r");          /* read-only permutation file  */
for (i0=0;i0<ninter;i0++)fscanf(f_perm,"%d",&perm[i0]);
fclose(f_perm);
printf("Closed.\n p[0]=%d,p[%d]=%d\n",perm[0],ninter-1,perm[ninter-1]);

/**************************  LFSR   **************************************/

fgets(stringa,128,f_input);                  /* inizialize the LFSR circuit*/
fscanf(f_input,"%u\n",&l_start);

/***************************  UNIF   **************************************/

fgets(stringa,128,f_input);                  /* inizialize the LFSR circuit*/
fscanf(f_input,"%d\n",&vc_un_start);



/**************************  S/N   **************************************/

fgets(stringa,128,f_input);                  /* inizialize the LFSR circuit*/
fscanf(f_input,"%lf\n",&s_n_db);

/**************************  DELTA  **************************************/

fgets(stringa,128,f_input);                  /* inizialize the LFSR circuit*/
fscanf(f_input,"%lf\n",&delta_s_n_db);

s_n_db = s_n_db - delta_s_n_db;

/**************************  STEP **************************************/

fgets(stringa,128,f_input);                  /* inizialize the LFSR circuit*/
fscanf(f_input,"%d\n",&numero_step);

/**************************  FRAME  **************************************/
fgets(stringa,128,f_input);                  /* inizialize the LFSR circuit*/
fscanf(f_input,"%d\n",&numero_frame);

/**************************  ITERAZIONI  **************************************/

fgets(stringa,128,f_input);                  /* inizialize the LFSR circuit*/
fscanf(f_input,"%d\n",&niterazioni);

/**************************  Initial Delay **************************************/

fgets(stringa,128,f_input);                  /* inizialize the LFSR circuit*/
fscanf(f_input,"%d\n",&f_delay);

/**************************  Check results  **************************************/

fgets(stringa,128,f_input);                  /* inizialize the LFSR circuit*/
fscanf(f_input,"%d\n",&ncheck);

/**************************  MAX NUMBER OF ERRORS  **********************************/

fgets(stringa,128,f_input);                  /* inizialize the LFSR circuit*/
fscanf(f_input,"%d\n",&nerr_max);
fclose(f_input);

printf("Permutation: %s \n",name);
printf("Seed of pseudorandom input sequence: %u \n",l_start);
printf("Seed of noise generator: %d \n",vc_un_start);
printf("Starting Eb/N0: %2.2f dB \n",s_n_db);
printf("Eb/N0 step %2.2f dB \n",delta_s_n_db);
printf("Number of simulations point %d \n",numero_step);
printf("Number of iterations %3d \n",niterazioni);
printf("Number of frame to be simulated %6d \n",numero_frame);
printf("Write results period %3d \n",ncheck);
printf("Maximum number of frame errors %3d \n",nerr_max);

fprintf(f_stat,"# Permutation: %s \n",name);
fprintf(f_stat,"# Seed of pseudorandom input sequence: %u \n",l_start);
fprintf(f_stat,"# Seed of noise generator: %d \n",vc_un_start);

fprintf(f_BER,"# Permutation: %s \n",name);
fprintf(f_BER,"# Seed of pseudorandom input sequence: %u \n",l_start);
fprintf(f_BER,"# Seed of noise generator: %d \n",vc_un_start);

fprintf(f_FER,"# Permutation: %s \n",name);
fprintf(f_FER,"# Seed of pseudorandom input sequence: %u \n",l_start);
fprintf(f_FER,"# Seed of noise generator: %d \n",vc_un_start);
} 
