/*************************************************************************/
/*************** intermediate_results      ********************************/
/*************************************************************************/
void intermediate_results()
{
	double sim_t;
	double s_n_db_true;
	sim_t =   (double) (1000.) * (ck_t - ck) / CLOCKS_PER_SEC;
   printf("\n");
   printf("\nrate 1/3 Nominal Eb/N0 = %f [dB]",s_n_db);
	s_n_db_true= 10.*log10(total_rx_pwr/total_rx_nse)
		         -10.*log10(nframe*2./ncod)
		         +10.*log10((ncod+4.*8.*SLOT_PER_FRAME)/ncod);
	printf(" True Eb/N0 = %f [dB]",s_n_db_true);
	printf("\nIntermediate Results:    Frame: %6d su %6d",f-f_delay+1,numero_frame);
	for(i=0;i<niterazioni;i++)
	{
		printf("\n %2d Pb(e)= %.3e (%8u)",i+1,(bit_err[i])/(double)nframe/(f-f_delay+1),bit_err[i]);
		printf(" Pw(e)= %.3e (%8u)",frame_err[i]/1./(f-f_delay+1),frame_err[i]);
	}
	printf("\nSimulator speed: %5.3f [kbps] %5.3f [frame/s]\n",
		 (double)(ncheck*nframe)/sim_t,
		 (double)(ncheck)*1000./sim_t);

}

/*************************************************************************/
/***********************   final_results     ********************************/
/*************************************************************************/
void final_results()
{
	double s_n_db_true;
printf("\nEnd simulation number %d of %d (%2.2f [dB]) \n",
	   step+1,numero_step,s_n_db);
printf("Number of simulated bits : %10d \n",(f-f_delay)*nframe);
printf("Number of simulated bits: %10d \n",f-f_delay);
for(i=0;i<niterazioni;i++)
{
	printf(" %2d Pb(e)  = %.3e (%8u)",i+1,(bit_err[i])/(double)nframe/(f-f_delay),bit_err[i]);
	printf(" Pw(e)  = %.3e (%8u)\n",frame_err[i]/1./(f-f_delay),frame_err[i]);
	 }



/* BER and FER */
s_n_db_true=(double)( 10.*log10(total_rx_pwr/total_rx_nse)
		      -10.*log10(nframe*2./ncod)
		      +10.*log10((ncod+4.*8.*SLOT_PER_FRAME)/ncod));
fprintf(f_BER,"%f|",s_n_db);
fprintf(f_FER,"%f|",s_n_db);
fprintf(f_BER,"%f|",s_n_db_true);
fprintf(f_FER,"%f|",s_n_db_true);
fprintf(f_BER,"%10d|",(f-f_delay)*nframe);
fprintf(f_FER,"%7d|",f-f_delay);
for(i=0;i<niterazioni;i++)
{
	fprintf(f_BER,"%.3e|",(bit_err[i])/(double)nframe/(f-f_delay));
	fprintf(f_FER,"%.3e|",frame_err[i]/1./(f-f_delay),frame_err[i]);
}
for(i=0;i<niterazioni;i++)
{
	fprintf(f_BER," %10d|",bit_err[i]);
	fprintf(f_FER," %7d|",frame_err[i]);
}
fprintf(f_BER,"\n");
fprintf(f_FER,"\n");
fflush(f_BER);
fflush(f_FER);

/* Statistics */
fprintf(f_stat,"Eb/N0:%f |",s_n_db);
fprintf(f_stat,"Nframe: %8d |\n",(f-f_delay));
for(i=0;i<niterazioni;i++)
	{	
		fprintf(f_stat,"%2d|",i);
		fprintf(f_stat,"%8d|",frame_err[i]);
		for(j=0;j<stat_max;j++)fprintf(f_stat,"%5d|",stat_err[i][j]);
		fprintf(f_stat,"\n");

	}
fflush(f_stat);
}


